/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved. 
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0  
 
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, 
MERCHANTABLITY OR NON-INFRINGEMENT. 
 
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */



/// <引用 不用默认库= "真"/>



//@@{ 数组_:Array }
接口 数组_<T> {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: T, 从指数?: 数字): 真假;

}

//@@{ 只读数组_:ReadonlyArray }
接口 只读数组_<T> {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: T, 从指数?: 数字): 真假;

}

//@@{ 整数数组8_:Int8Array }
接口 整数数组8_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 正整数数组8_:Uint8Array }
接口 正整数数组8_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 正整数固定数组8_:Uint8ClampedArray }
接口 正整数固定数组8_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 整数数组16_:Int16Array }
接口 整数数组16_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 正整数数组16_:Uint16Array }
接口 正整数数组16_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 整数数组32_:Int32Array }
接口 整数数组32_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 正整数数组32_:Uint32Array }
接口 正整数数组32_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 浮点数组32_:Float32Array }
接口 浮点数组32_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;

}

//@@{ 浮点数组64_:Float64Array }
接口 浮点数组64_ {

    /**
     * Determines whether an array includes a certain element, returning true or false as appropriate.
     * @param 搜索元素 The element to search for.
     * @param 从指数 The position in this array at which to begin searching for searchElement.
     */

    //@@{ 包括:includes, 搜索元素:searchElement, 从指数:fromIndex }
    包括(搜索元素: 数字, 从指数?: 数字): 真假;
}